Index: kernel/generic/src/ipc/kbox.c
===================================================================
--- kernel/generic/src/ipc/kbox.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ipc/kbox.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -90,5 +90,4 @@
 		LOG("Join kb.thread.");
 		thread_join(TASK->kb.thread);
-		thread_detach(TASK->kb.thread);
 		LOG("...join done.");
 		TASK->kb.thread = NULL;
@@ -136,6 +135,6 @@
 		/* Only detach kbox thread unless already terminating. */
 		if (TASK->kb.finished == false) {
-			/* Detach kbox thread so it gets freed from memory. */
-			thread_detach(TASK->kb.thread);
+			/* Release kbox thread so it gets freed from memory. */
+			thread_put(TASK->kb.thread);
 			TASK->kb.thread = NULL;
 		}
@@ -201,9 +200,4 @@
 /** Connect phone to a task kernel-box specified by id.
  *
- * Note that this is not completely atomic. For optimisation reasons, the task
- * might start cleaning up kbox after the phone has been connected and before
- * a kbox thread has been created. This must be taken into account in the
- * cleanup code.
- *
  * @param[out] out_phone  Phone capability handle on success.
  * @return Error code.
@@ -212,26 +206,13 @@
 errno_t ipc_connect_kbox(task_id_t taskid, cap_phone_handle_t *out_phone)
 {
-	irq_spinlock_lock(&tasks_lock, true);
-
 	task_t *task = task_find_by_id(taskid);
-	if (task == NULL) {
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ENOENT;
-	}
-
-	atomic_inc(&task->refcount);
-
-	irq_spinlock_unlock(&tasks_lock, true);
 
 	mutex_lock(&task->kb.cleanup_lock);
-
-	if (atomic_predec(&task->refcount) == 0) {
-		mutex_unlock(&task->kb.cleanup_lock);
-		task_destroy(task);
-		return ENOENT;
-	}
 
 	if (task->kb.finished) {
 		mutex_unlock(&task->kb.cleanup_lock);
+		task_release(task);
 		return EINVAL;
 	}
@@ -244,9 +225,10 @@
 		if (!kb_thread) {
 			mutex_unlock(&task->kb.cleanup_lock);
+			task_release(task);
 			return ENOMEM;
 		}
 
 		task->kb.thread = kb_thread;
-		thread_ready(kb_thread);
+		thread_start(kb_thread);
 	}
 
@@ -256,4 +238,5 @@
 	if (rc != EOK) {
 		mutex_unlock(&task->kb.cleanup_lock);
+		task_release(task);
 		return rc;
 	}
@@ -266,4 +249,5 @@
 
 	mutex_unlock(&task->kb.cleanup_lock);
+	task_release(task);
 	*out_phone = phone_handle;
 	return EOK;
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ipc/sysipc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
 #include <assert.h>
 #include <errno.h>
-#include <mem.h>
+#include <memw.h>
 #include <ipc/ipc.h>
 #include <abi/ipc/methods.h>
@@ -871,5 +871,5 @@
 sys_errno_t sys_ipc_poke(void)
 {
-	waitq_wakeup(&TASK->answerbox.wq, WAKEUP_FIRST);
+	waitq_wake_one(&TASK->answerbox.wq);
 	return EOK;
 }
Index: kernel/generic/src/lib/mem.c
===================================================================
--- kernel/generic/src/lib/mem.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/lib/mem.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,5 +41,5 @@
  */
 
-#include <mem.h>
+#include <memw.h>
 #include <typedefs.h>
 
@@ -77,49 +77,4 @@
 }
 
-/** Move memory block with possible overlapping.
- *
- * Copy cnt bytes from src address to dst address. The source
- * and destination memory areas may overlap.
- *
- * @param dst Destination address to copy to.
- * @param src Source address to copy from.
- * @param cnt Number of bytes to copy.
- *
- * @return Destination address.
- *
- */
-void *memmove(void *dst, const void *src, size_t cnt)
-{
-	/* Nothing to do? */
-	if (src == dst)
-		return dst;
-
-	/* Non-overlapping? */
-	if ((dst >= src + cnt) || (src >= dst + cnt))
-		return memcpy(dst, src, cnt);
-
-	uint8_t *dp;
-	const uint8_t *sp;
-
-	/* Which direction? */
-	if (src > dst) {
-		/* Forwards. */
-		dp = dst;
-		sp = src;
-
-		while (cnt-- != 0)
-			*dp++ = *sp++;
-	} else {
-		/* Backwards. */
-		dp = dst + (cnt - 1);
-		sp = src + (cnt - 1);
-
-		while (cnt-- != 0)
-			*dp-- = *sp--;
-	}
-
-	return dst;
-}
-
 /** @}
  */
Index: kernel/generic/src/lib/ra.c
===================================================================
--- kernel/generic/src/lib/ra.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/lib/ra.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -81,5 +81,5 @@
 }
 
-static hash_table_ops_t used_ops = {
+static const hash_table_ops_t used_ops = {
 	.hash = used_hash,
 	.key_hash = used_key_hash,
Index: kernel/generic/src/lib/ubsan.c
===================================================================
--- kernel/generic/src/lib/ubsan.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/lib/ubsan.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -10,5 +10,5 @@
 #include <stddef.h>
 #include <panic.h>
-#include <mem.h>
+#include <memw.h>
 
 #define PRINTF(...) printf(__VA_ARGS__)
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/main/kinit.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -61,5 +61,5 @@
 #include <stdio.h>
 #include <log.h>
-#include <mem.h>
+#include <memw.h>
 #include <console/console.h>
 #include <interrupt.h>
@@ -69,8 +69,10 @@
 #include <ipc/ipc.h>
 #include <str.h>
+#include <str_error.h>
 #include <sysinfo/stats.h>
 #include <sysinfo/sysinfo.h>
 #include <align.h>
 #include <stdlib.h>
+#include <debug/register.h>
 
 #ifdef CONFIG_SMP
@@ -102,14 +104,9 @@
 	thread_t *thread;
 
-	/*
-	 * Detach kinit as nobody will call thread_join_timeout() on it.
-	 */
-	thread_detach(THREAD);
-
 	interrupts_disable();
 
 #ifdef CONFIG_SMP
 	if (config.cpu_count > 1) {
-		waitq_initialize(&ap_completion_wq);
+		semaphore_initialize(&ap_completion_semaphore, 0);
 
 		/*
@@ -125,7 +122,6 @@
 
 		thread_wire(thread, &cpus[0]);
-		thread_ready(thread);
+		thread_start(thread);
 		thread_join(thread);
-		thread_detach(thread);
 
 		/*
@@ -139,5 +135,6 @@
 			if (thread != NULL) {
 				thread_wire(thread, &cpus[i]);
-				thread_ready(thread);
+				thread_start(thread);
+				thread_detach(thread);
 			} else
 				log(LF_OTHER, LVL_ERROR,
@@ -155,8 +152,10 @@
 	thread = thread_create(kload, NULL, TASK, THREAD_FLAG_NONE,
 	    "kload");
-	if (thread != NULL)
-		thread_ready(thread);
-	else
+	if (thread != NULL) {
+		thread_start(thread);
+		thread_detach(thread);
+	} else {
 		log(LF_OTHER, LVL_ERROR, "Unable to create kload thread");
+	}
 
 #ifdef CONFIG_KCONSOLE
@@ -167,9 +166,11 @@
 		thread = thread_create(kconsole_thread, NULL, TASK,
 		    THREAD_FLAG_NONE, "kconsole");
-		if (thread != NULL)
-			thread_ready(thread);
-		else
+		if (thread != NULL) {
+			thread_start(thread);
+			thread_detach(thread);
+		} else {
 			log(LF_OTHER, LVL_ERROR,
 			    "Unable to create kconsole thread");
+		}
 	}
 #endif /* CONFIG_KCONSOLE */
@@ -187,5 +188,5 @@
 	 */
 	size_t i;
-	program_t programs[CONFIG_INIT_TASKS];
+	program_t programs[CONFIG_INIT_TASKS] = { };
 
 	// FIXME: do not propagate arguments through sysinfo
@@ -242,4 +243,16 @@
 		    PAGE_READ | PAGE_WRITE | PAGE_CACHEABLE);
 		assert(page);
+
+		if (str_cmp(name, "kernel.dbg") == 0) {
+			/*
+			 * Not an actual init task, but rather debug sections extracted
+			 * from the kernel ELF file and handed to us here so we can use
+			 * it for debugging.
+			 */
+
+			register_debug_data((void *) page, init.tasks[i].size);
+			programs[i].task = NULL;
+			continue;
+		}
 
 		if (str_cmp(name, "loader") == 0) {
@@ -259,5 +272,5 @@
 		}
 
-		errno_t rc = program_create_from_image((void *) page, namebuf,
+		errno_t rc = program_create_from_image((void *) page, init.tasks[i].size, namebuf,
 		    &programs[i]);
 
@@ -300,6 +313,8 @@
 	 */
 	for (i = 0; i < init.cnt; i++) {
-		if (programs[i].task != NULL)
+		if (programs[i].task != NULL) {
 			program_ready(&programs[i]);
+			task_release(programs[i].task);
+		}
 	}
 
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/main/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -80,5 +80,4 @@
 #include <arch/arch.h>
 #include <arch.h>
-#include <arch/faddr.h>
 #include <ipc/ipc.h>
 #include <macros.h>
@@ -132,8 +131,12 @@
 };
 
-context_t ctx;
-
-/** Lowest safe stack virtual address. */
-uintptr_t stack_safe = 0;
+static context_t ctx;
+
+// NOTE: All kernel stacks must be aligned to STACK_SIZE, see CURRENT.
+static const size_t bootstrap_stack_size = STACK_SIZE;
+static _Alignas(STACK_SIZE) uint8_t bootstrap_stack[STACK_SIZE];
+
+/* Just a convenient value for some assembly code. */
+uint8_t *const bootstrap_stack_top = bootstrap_stack + STACK_SIZE;
 
 /*
@@ -170,38 +173,6 @@
 	    ALIGN_UP((uintptr_t) kdata_end - config.base, PAGE_SIZE);
 
-	/*
-	 * NOTE: All kernel stacks must be aligned to STACK_SIZE,
-	 *       see CURRENT.
-	 */
-
-	/* Place the stack after the kernel, init and ballocs. */
-	config.stack_base =
-	    ALIGN_UP(config.base + config.kernel_size, STACK_SIZE);
-	config.stack_size = STACK_SIZE;
-
-	/* Avoid placing stack on top of init */
-	size_t i;
-	for (i = 0; i < init.cnt; i++) {
-		uintptr_t p = init.tasks[i].paddr + init.tasks[i].size;
-		uintptr_t bottom = PA2KA(ALIGN_UP(p, STACK_SIZE));
-
-		if (config.stack_base < bottom)
-			config.stack_base = bottom;
-	}
-
-	/* Avoid placing stack on top of boot allocations. */
-	if (ballocs.size) {
-		uintptr_t bottom =
-		    ALIGN_UP(ballocs.base + ballocs.size, STACK_SIZE);
-		if (config.stack_base < bottom)
-			config.stack_base = bottom;
-	}
-
-	if (config.stack_base < stack_safe)
-		config.stack_base = ALIGN_UP(stack_safe, STACK_SIZE);
-
-	context_save(&ctx);
-	context_set(&ctx, FADDR(main_bsp_separated_stack),
-	    config.stack_base, STACK_SIZE);
+	context_create(&ctx, main_bsp_separated_stack,
+	    bootstrap_stack, bootstrap_stack_size);
 	context_restore(&ctx);
 	/* not reached */
@@ -220,8 +191,6 @@
 	version_print();
 
-	LOG("\nconfig.base=%p config.kernel_size=%zu"
-	    "\nconfig.stack_base=%p config.stack_size=%zu",
-	    (void *) config.base, config.kernel_size,
-	    (void *) config.stack_base, config.stack_size);
+	LOG("\nconfig.base=%p config.kernel_size=%zu",
+	    (void *) config.base, config.kernel_size);
 
 #ifdef CONFIG_KCONSOLE
@@ -311,11 +280,13 @@
 	if (!kinit_thread)
 		panic("Cannot create kinit thread.");
-	thread_ready(kinit_thread);
-
-	/*
-	 * This call to scheduler() will return to kinit,
+	thread_start(kinit_thread);
+	thread_detach(kinit_thread);
+
+	/*
+	 * This call to scheduler_run() will return to kinit,
 	 * starting the thread of kernel threads.
 	 */
-	scheduler();
+	current_copy(CURRENT, (current_t *) CPU_LOCAL->stack);
+	context_replace(scheduler_run, CPU_LOCAL->stack, STACK_SIZE);
 	/* not reached */
 }
@@ -357,6 +328,4 @@
 	ARCH_OP(post_cpu_init);
 
-	current_copy(CURRENT, (current_t *) CPU->stack);
-
 	/*
 	 * If we woke kmp up before we left the kernel stack, we could
@@ -364,8 +333,6 @@
 	 * switch to this cpu's private stack prior to waking kmp up.
 	 */
-	context_save(&CPU->saved_context);
-	context_set(&CPU->saved_context, FADDR(main_ap_separated_stack),
-	    (uintptr_t) CPU->stack, STACK_SIZE);
-	context_restore(&CPU->saved_context);
+	current_copy(CURRENT, (current_t *) CPU_LOCAL->stack);
+	context_replace(main_ap_separated_stack, CPU_LOCAL->stack, STACK_SIZE);
 	/* not reached */
 }
@@ -383,6 +350,6 @@
 	timeout_init();
 
-	waitq_wakeup(&ap_completion_wq, WAKEUP_FIRST);
-	scheduler();
+	semaphore_up(&ap_completion_semaphore);
+	scheduler_run();
 	/* not reached */
 }
Index: kernel/generic/src/main/uinit.c
===================================================================
--- kernel/generic/src/main/uinit.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/main/uinit.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -56,14 +56,4 @@
 void uinit(void *arg)
 {
-	/*
-	 * So far, we don't have a use for joining userspace threads so we
-	 * immediately detach each uinit thread. If joining of userspace threads
-	 * is required, some userspace API based on the kernel mechanism will
-	 * have to be implemented. Moreover, garbage collecting of threads that
-	 * didn't detach themselves and nobody else joined them will have to be
-	 * deployed for the event of forceful task termination.
-	 */
-	thread_detach(THREAD);
-
 #ifdef CONFIG_UDEBUG
 	udebug_stoppable_end();
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/as.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -69,5 +69,5 @@
 #include <assert.h>
 #include <stdio.h>
-#include <mem.h>
+#include <memw.h>
 #include <macros.h>
 #include <bitops.h>
@@ -86,5 +86,5 @@
  * address space operations such as creating or locking page tables.
  */
-as_operations_t *as_operations = NULL;
+const as_operations_t *as_operations = NULL;
 
 /** Cache for as_t objects */
@@ -1688,5 +1688,10 @@
 	spinlock_unlock(&asidlock);
 
+	if (AS)
+		as_release(AS);
+
 	AS = new_as;
+
+	as_hold(AS);
 }
 
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/backend_anon.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -51,5 +51,5 @@
 #include <typedefs.h>
 #include <align.h>
-#include <mem.h>
+#include <memw.h>
 #include <arch.h>
 
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/backend_elf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -48,5 +48,5 @@
 #include <genarch/mm/page_ht.h>
 #include <align.h>
-#include <mem.h>
+#include <memw.h>
 #include <macros.h>
 #include <arch.h>
Index: kernel/generic/src/mm/backend_user.c
===================================================================
--- kernel/generic/src/mm/backend_user.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/backend_user.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -50,4 +50,5 @@
 #include <log.h>
 #include <str.h>
+#include <str_error.h>
 
 static bool user_create(as_area_t *);
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/frame.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -753,5 +753,5 @@
 
 				if (overlaps(addr, PFN2ADDR(confcount),
-				    KA2PA(config.stack_base), config.stack_size))
+				    KA2PA(ballocs.base), ballocs.size))
 					continue;
 
@@ -1121,6 +1121,4 @@
 		frame_mark_unavailable(ADDR2PFN(KA2PA(config.base)),
 		    SIZE2FRAMES(config.kernel_size));
-		frame_mark_unavailable(ADDR2PFN(KA2PA(config.stack_base)),
-		    SIZE2FRAMES(config.stack_size));
 
 		for (size_t i = 0; i < init.cnt; i++)
Index: kernel/generic/src/mm/km.c
===================================================================
--- kernel/generic/src/mm/km.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/km.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -166,10 +166,11 @@
 	page_table_lock(AS_KERNEL, true);
 
-	ipl = tlb_shootdown_start(TLB_INVL_ASID, ASID_KERNEL, 0, 0);
+	size_t pages = size >> PAGE_WIDTH;
+	ipl = tlb_shootdown_start(TLB_INVL_PAGES, ASID_KERNEL, vaddr, pages);
 
 	for (offs = 0; offs < size; offs += PAGE_SIZE)
 		page_mapping_remove(AS_KERNEL, vaddr + offs);
 
-	tlb_invalidate_asid(ASID_KERNEL);
+	tlb_invalidate_pages(ASID_KERNEL, vaddr, pages);
 
 	as_invalidate_translation_cache(AS_KERNEL, 0, -1);
@@ -203,5 +204,5 @@
  *
  * @param vaddr		Virtual address to be unmapped. May be unaligned, but
- *			it must a value previously returned by km_map().
+ *			it must be a value previously returned by km_map().
  * @param size		Size of area starting at vaddr to be unmapped.
  */
Index: kernel/generic/src/mm/malloc.c
===================================================================
--- kernel/generic/src/mm/malloc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/malloc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -34,5 +34,5 @@
 #include <bitops.h>
 #include <mm/slab.h>
-#include <mem.h>
+#include <memw.h>
 #include <main/main.h> // malloc_init()
 #include <macros.h>
Index: kernel/generic/src/mm/page.c
===================================================================
--- kernel/generic/src/mm/page.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/page.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -76,5 +76,5 @@
 
 /** Virtual operations for page subsystem. */
-page_mapping_operations_t *page_mapping_operations = NULL;
+const page_mapping_operations_t *page_mapping_operations = NULL;
 
 void page_init(void)
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/slab.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -106,5 +106,5 @@
 #include <mm/slab.h>
 #include <adt/list.h>
-#include <mem.h>
+#include <memw.h>
 #include <align.h>
 #include <mm/frame.h>
Index: kernel/generic/src/mm/tlb.c
===================================================================
--- kernel/generic/src/mm/tlb.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/tlb.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -95,5 +95,5 @@
 		cpu_t *cpu = &cpus[i];
 
-		irq_spinlock_lock(&cpu->lock, false);
+		irq_spinlock_lock(&cpu->tlb_lock, false);
 		if (cpu->tlb_messages_count == TLB_MESSAGE_QUEUE_LEN) {
 			/*
@@ -116,5 +116,5 @@
 			cpu->tlb_messages[idx].count = count;
 		}
-		irq_spinlock_unlock(&cpu->lock, false);
+		irq_spinlock_unlock(&cpu->tlb_lock, false);
 	}
 
@@ -158,5 +158,5 @@
 	irq_spinlock_unlock(&tlblock, false);
 
-	irq_spinlock_lock(&CPU->lock, false);
+	irq_spinlock_lock(&CPU->tlb_lock, false);
 	assert(CPU->tlb_messages_count <= TLB_MESSAGE_QUEUE_LEN);
 
@@ -189,5 +189,5 @@
 
 	CPU->tlb_messages_count = 0;
-	irq_spinlock_unlock(&CPU->lock, false);
+	irq_spinlock_unlock(&CPU->tlb_lock, false);
 	CPU->tlb_active = true;
 }
Index: kernel/generic/src/printf/vsnprintf.c
===================================================================
--- kernel/generic/src/printf/vsnprintf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/printf/vsnprintf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
 #include <printf/printf_core.h>
 #include <str.h>
-#include <mem.h>
+#include <memw.h>
 #include <errno.h>
 
Index: kernel/generic/src/proc/current.c
===================================================================
--- kernel/generic/src/proc/current.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/proc/current.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -55,4 +55,5 @@
 {
 	the->preemption = 0;
+	the->mutex_locks = 0;
 	the->cpu = NULL;
 	the->thread = NULL;
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/proc/program.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -49,4 +49,5 @@
 #include <lib/elf_load.h>
 #include <str.h>
+#include <str_error.h>
 #include <log.h>
 #include <syscall/copy.h>
@@ -98,5 +99,5 @@
 	if (!area) {
 		free(kernel_uarg);
-		task_destroy(prg->task);
+		task_release(prg->task);
 		prg->task = NULL;
 		return ENOMEM;
@@ -118,5 +119,5 @@
 		free(kernel_uarg);
 		as_area_destroy(as, virt);
-		task_destroy(prg->task);
+		task_release(prg->task);
 		prg->task = NULL;
 		return ELIMIT;
@@ -142,5 +143,5 @@
  *
  */
-errno_t program_create_from_image(void *image_addr, char *name, program_t *prg)
+errno_t program_create_from_image(void *image_addr, size_t image_size, char *name, program_t *prg)
 {
 	as_t *as = as_create(0);
@@ -156,6 +157,14 @@
 	}
 
-	return program_create(as, ((elf_header_t *) image_addr)->e_entry,
+	errno_t rc = program_create(as, ((elf_header_t *) image_addr)->e_entry,
 	    name, prg);
+
+	if (rc == EOK) {
+		prg->task->debug_sections = calloc(1, sizeof(debug_sections_t));
+		if (prg->task->debug_sections != NULL)
+			*prg->task->debug_sections = get_debug_sections(image_addr, image_size);
+	}
+
+	return rc;
 }
 
@@ -203,5 +212,7 @@
 void program_ready(program_t *prg)
 {
-	thread_ready(prg->main_thread);
+	thread_start(prg->main_thread);
+	thread_detach(prg->main_thread);
+	prg->main_thread = NULL;
 }
 
@@ -241,4 +252,6 @@
 	program_ready(&prg);
 
+	task_release(prg.task);
+
 	return EOK;
 }
